package arabiannight.tistory.com.status;

import android.app.Activity;
import android.content.Context;
import android.graphics.Rect;
import android.os.Bundle;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.Window;
import android.view.WindowManager;
import android.widget.LinearLayout;

public class TestStatusBarHeightActivity extends Activity {

	private static final int LOW_DPI_STATUS_BAR_HEIGHT = 19;
	private static final int MEDIUM_DPI_STATUS_BAR_HEIGHT = 25;
	private static final int HIGH_DPI_STATUS_BAR_HEIGHT = 38;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		getStatusBarSizeOnCreate();
		
		LinearLayout layout = new LinearLayout(this);
		layout.post(new Runnable() {
			@Override
			public void run() {
				getStatusBarSize(); 
			}
		});
	}
	
	// StatusBar Size 구하는 메서드 ( onCreate에서 실행 불가능 )
	private void getStatusBarSize(){ 
		Rect rectgle= new Rect();
		Window window= getWindow();
		window.getDecorView().getWindowVisibleDisplayFrame(rectgle);
		int StatusBarHeight= rectgle.top;
		int contentViewTop= 
				window.findViewById(Window.ID_ANDROID_CONTENT).getTop();
		int TitleBarHeight= contentViewTop - StatusBarHeight;
		Log.i("StatusBarTest" , "StatusBar Height= " + StatusBarHeight +
				" TitleBar Height = " + TitleBarHeight);
	}
	
	// onCreate()에서 StatusBar 구하는 메서드 ( Density 이용 )
	private void getStatusBarSizeOnCreate(){ 
		DisplayMetrics displayMetrics = new DisplayMetrics();
		((WindowManager) getSystemService(Context.WINDOW_SERVICE))
		.getDefaultDisplay().getMetrics(displayMetrics);

		int statusBarHeight;

		switch (displayMetrics.densityDpi) {
		    case DisplayMetrics.DENSITY_HIGH:
		        statusBarHeight = HIGH_DPI_STATUS_BAR_HEIGHT;
		        break;
		    case DisplayMetrics.DENSITY_MEDIUM:
		        statusBarHeight = MEDIUM_DPI_STATUS_BAR_HEIGHT;
		        break;
		    case DisplayMetrics.DENSITY_LOW:
		        statusBarHeight = LOW_DPI_STATUS_BAR_HEIGHT;
		        break;
		    default:
		        statusBarHeight = MEDIUM_DPI_STATUS_BAR_HEIGHT;
		}
		Log.i("StatusBarTest" , "onCreate StatusBar Height= " + statusBarHeight);
	}
}


// 출처 : http://stackoverflow.com/questions/3407256/height-of-status-bar-in-android
